function createAuthorizationError() {
  const authorizationError = new Error();
  authorizationError.isAuthorizationError = true;
  return authorizationError;
}

function handleAuthorizationError(err, req, res, next) {
  if (err.isAuthorizationError) {
    const json = err.json || { message: 'Authorization Failed.' };
    res
      .status(401)
      .json(json);
  } else {
    next(err);
  }
}

module.exports.createAuthorizationError = createAuthorizationError;
module.exports.handleAuthorizationError = handleAuthorizationError;
